#include "arc/math/rectangle.h"

//VERY TEMP
// #include <SDL.h>

void ARC_Rect_CenterOn(ARC_Rect *rect, ARC_Rect *bounds){
    rect->x = (bounds->x + (bounds->w / 2)) - (rect->w / 2);
    rect->y = (bounds->y + (bounds->h / 2)) - (rect->h / 2);
}

void ARC_FRect_CenterOn(ARC_FRect *rect, ARC_FRect *bounds){
    rect->x = (bounds->x + (bounds->w / 2.0f)) - (rect->w / 2.0f);
    rect->y = (bounds->y + (bounds->h / 2.0f)) - (rect->h / 2.0f);
}

ARC_FRect ARC_Rect_CastToFRect(ARC_Rect *rect){
    return (ARC_FRect){
        .x = (float)rect->x,
        .y = (float)rect->y,
        .w = (float)rect->w,
        .h = (float)rect->h,
    };
}

ARC_Rect ARC_FRect_CastToRect(ARC_FRect *rect){
    return (ARC_Rect){
        .x = (int32_t)rect->x,
        .y = (int32_t)rect->y,
        .w = (int32_t)rect->w,
        .h = (int32_t)rect->h,
    };
}

int32_t ARC_Rect_Intersects(ARC_Rect *rect1, ARC_Rect *rect2){
    if(rect1->x <= rect2->x + rect2->w && rect1->x + rect1->w >= rect2->x &&
       rect1->y <= rect2->y + rect2->h && rect1->y + rect1->h >= rect2->y){
        return 1;
    }
    return 0;
}

int32_t ARC_FRect_Intersects(ARC_FRect *rect1, ARC_FRect *rect2){
    if(rect1->x <= rect2->x + rect2->w && rect1->x + rect1->w >= rect2->x &&
       rect1->y <= rect2->y + rect2->h && rect1->y + rect1->h >= rect2->y){
        return 1;
    }
    return 0;
}

int32_t ARC_Rect_IntersectsPoint(ARC_Rect *rect, ARC_Point *point){
    if(rect->x <= point->x && rect->x + rect->w >= point->x &&
       rect->y <= point->y && rect->y + rect->h >= point->y){
        return 1;
    }
    return 0;
}

int32_t ARC_FRect_IntersectsPoint(ARC_FRect *rect, ARC_Point *point){
    if(rect->x <= point->x && rect->x + rect->w >= point->x &&
       rect->y <= point->y && rect->y + rect->h >= point->y){
        return 1;
    }
    return 0;
}

int32_t ARC_Rect_LineIntersects(ARC_Rect *rect, int32_t *x1, int32_t *y1, int32_t *x2, int32_t *y2){
    //TODO: Replace soon
    // return SDL_IntersectRectAndLine((SDL_Rect *) rect, x1, y1, x2, y2);
    return 1;
}

//TODO: position 1px away from colliding, so if velocity is greater than 2px it doesn't have weird gap spacing
//      might need to check diagnals as well, this is a rudamentry implementation
void ARC_FRect_CollideAndSlide(ARC_FRect *rect, ARC_Vector2 *velocity, ARC_FRect *wall){
    ARC_FRect nextRectPosition = {
        .x = rect->x + velocity->x,
        .y = rect->y + velocity->y,
        .w = rect->w,
        .h = rect->h
    };

    //there is no collision, return
    if(!ARC_FRect_Intersects(&nextRectPosition, wall)){
        return;
    }

    nextRectPosition.x = rect->x + velocity->x;
    nextRectPosition.y = rect->y;
    if(ARC_FRect_Intersects(&nextRectPosition, wall)){
        velocity->x = 0;
    }

    nextRectPosition.x = rect->x;
    nextRectPosition.y = rect->y + velocity->y;
    if(ARC_FRect_Intersects(&nextRectPosition, wall)){
        velocity->y = 0;
    }
}